--[[ DEV NOTES
TEXTURES\SPELLACTIVATIONOVERLAYS\MONK_OX.BLP
TEXTURES\SPELLACTIVATIONOVERLAYS\BLOOD_BOIL.BLP (needs to be rotated 90 degree clockwise
TEXTURES\SPELLACTIVATIONOVERLAYS\GENERIC_ARC_04.BLP (PG indicator)
]]



-- from SpellActivationOverlay.lua
local complexLocationTable = {
	["RIGHT (FLIPPED)"] = {
		RIGHT = {	hFlip = true },
	},
	["BOTTOM (FLIPPED)"] = {
		BOTTOM = { vFlip = true },
	},
	["LEFT + RIGHT (FLIPPED)"] = {
		LEFT = {},
		RIGHT = { hFlip = true },
	},
	["TOP + BOTTOM (FLIPPED)"] = {
		TOP = {},
		BOTTOM = { vFlip = true },
	},
}

-- Beta Mode testing

local function NAOverlaysetTexture(frame, side, texture, sizeScale, startHidden, ...)
	local offsetX, offsetY, startHiden = ...
	if not shortScale then shortScale = 1 end
	local longSide = 256 * sizeScale;
	local shortSide = 128 * sizeScale; -- * shortScale;
	if not offsetX then offsetX = 0 end
	if not offsetY then offsetY = 0 end
	
	frame:ClearAllPoints()
	
	if side == "L" then
		local texLeft, texRight, texTop, texBottom = 0, 1, 0, 1
		frame:SetPoint("RIGHT", NorthernAle.northernAleOverlayFrame, "LEFT", offsetX, offsetY);
		frame:SetTexCoord(texLeft, texRight, texTop, texBottom)
	elseif side == "R" then
		offsetX = offsetX * -1
		local texLeft, texRight, texTop, texBottom = 1, 0, 0, 1
		frame:SetPoint("LEFT", NorthernAle.northernAleOverlayFrame, "RIGHT", offsetX, offsetY);
		frame:SetTexCoord(texLeft, texRight, texTop, texBottom)
	end
	frame:SetTexture(texture)
	-- print("created " .. frame:GetName() .. "'s " ..side .. " side texture")
	if startHidden then
		-- print(frame:GetName() .. " is hidden")
		frame:Hide()
	else
		frame:Show()
	end
end

local function fauxEAB()
	
end

-- Updaters

local function UpdateShuffle()
	-- print("Shuffle Update entered")
	if UnitBuff("player", "Shuffle") then
		-- print("Shuffle buff found")
		local n,_,icon,count,_,dur,expTime,_,_=UnitBuff("player", "Shuffle")
		local timeLeft = expTime - GetTime()
		if timeLeft < 0 then timeLeft = 0 end
		-- print("Shuffle Updating; duration left = " .. timeLeft)
		if tonumber(timeLeft) > 30 then timeLeft = "30" end
		if tonumber(timeLeft) <= 6 then
			NorthernAle.shufflestatusFrame:SetStatusBarColor(1, 0.04, 0.02, 1)
		elseif tonumber(timeLeft) > 5 then
			NorthernAle.shufflestatusFrame:SetStatusBarColor(0.33, 0.54, 0.52, 1)
		end
		NorthernAle.shufflestatusFrame:SetValue(tostring(timeLeft))
		NorthernAle.shufflestatusFrame:Show()
	else
		NorthernAle.shufflestatusFrame:SetValue("0")
	end
end

local function UpdateTigerPower()
	-- check if TigerPowerImage should be on
	local TigerPowerActive
	if UnitBuff("player", "Tiger Power") and NorthernAle.NorthernAleOptions.tigerPowerFrameOn then
		NorthernAle.leftTigerPowerImage:SetVertexColor(0.22, 0.76, 0.11, 1)
		NorthernAle.rightTigerPowerImage:SetVertexColor(0.22, 0.76, 0.11, 1) -- (57, 194, 29, 1)
		NorthernAle.leftTigerPowerImage:Show()
		NorthernAle.rightTigerPowerImage:Show()
	else
		NorthernAle.leftTigerPowerImage:Hide()
		NorthernAle.rightTigerPowerImage:Hide()
	end
end

-- Script handlers
local outOfCombatTime
function NorthernAle_OnLoad(self)
	-- verify player class and spec PLAYER_ALIVE
	self:RegisterEvent("PLAYER_ALIVE")
	
	local _, playerClass = UnitClass("player")
	if playerClass == "MONK" then
		-- print("You're a Monk!")
		if GetSpecialization() == 1 then
			print("You're a BrewMaster Monk!")
			NA_Load = true
		else
			NA_Load = false
		end
		self:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
		
	else
		NA_Load = false	
	end
	if NA_Load == false then
		print("Non BrewMaster Spec detected: disabling NorthernAle")
	
		return
	end
	
	
	local longSide = 256 * 0.8;
	self.northernAleOverlayFrame:SetSize(longSide, longSide)
	
	-- Create Options
	if not NorthernAle.NorthernAleOptions then
		print("Options reset")
		NorthernAle.NorthernAleOptions = {
			-- pgFrameOn = true,
			tigerPowerFrameOn = true,
			shuffleFrameOn = true,
			elusiveBrewButtonOn = true,
			procWatchOn = true,
			fauxStaggerOn = false,
		}
	end
	
	if NorthernAle.NorthernAleOptions.fauxStaggerOn then
		-- print("option works")
		

		-- create faux stagger overlay
		local stagtests = {
			[1] = {NorthernAle.lstagtest, "L",},
			[2] = {NorthernAle.rstagtest, "R",},
		}
		
		for idx = 1, #stagtests do
			-- print(stagtests[idx][1]:GetName(), stagtests[idx][2])
			NAOverlaysetTexture(stagtests[idx][1], stagtests[idx][2], "TEXTURES\\SPELLACTIVATIONOVERLAYS\\MONK_OX", 0.8, true)
		end
		self.overlaysInUse = {};
		self.unusedOverlays = {};
		-- NorthernAle.lstagtest:Show()
		-- NorthernAle.rstagtest:Show()
	else
		-- print(NorthernAle.NorthernAleOptions.fauxStaggerOn)
	end

	if NorthernAle.NorthernAleOptions.shuffleFrameOn then
		self.shufflestatusFrame:SetStatusBarTexture("TEXTURES\\SPELLACTIVATIONOVERLAYS\\GENERICTOP_01")
		self.shufflestatusFrame:SetStatusBarColor(0.33, 0.54, 0.52, 1)
		NorthernAle:RegisterEvent("UNIT_AURA")
		UpdateShuffle()
		--self.shufflestatusFrame:SetRotatesTexture(true)
	end
	
	if NorthernAle.NorthernAleOptions.tigerPowerFrameOn then
		-- create PS_PG textures
		local TigerPowerImageFrames = {
			[1] = {NorthernAle.leftTigerPowerImage, "L",},
			[2] = {NorthernAle.rightTigerPowerImage, "R",},
		}
		for idx = 1, #TigerPowerImageFrames do
			-- print(TigerPowerImageFrames[idx][1]:GetName(), TigerPowerImageFrames[idx][2])
			NAOverlaysetTexture(TigerPowerImageFrames[idx][1], TigerPowerImageFrames[idx][2], "TEXTURES\\SPELLACTIVATIONOVERLAYS\\GENERICARC_04", 0.4, 40, false)
		end
		-- register and run
		NorthernAle:RegisterEvent("UNIT_AURA")
		UpdateTigerPower()
	end
	
	-- self:Show()
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
end

function NorthernAle_OnEvent(self, event, ...)
	if event == "ACTIVE_TALENT_GROUP_CHANGED" or event == "PLAYER_ALIVE" then
		NorthernAle_OnLoad(self)
	end
	if NA_Load then
		if event == "UNIT_AURA" then
			UpdateShuffle()
			UpdateTigerPower()
		elseif event == "PLAYER_REGEN_ENABLED" then
			outOfCombatTime = GetTime()
		end
	end
end

-- OnUpdate
local elapsedTime = 0
function NorthernAle_OnUpdate(self, elapsed)
	if NA_Load then
		if outOfCombatTime then
			local currentTime = GetTime()
			if (currentTime - outOfCombatTime) > 5 then
				print("Left Combat; hiding NA Frames.")
				NorthernAle.leftTigerPowerImage:Hide()
				NorthernAle.rightTigerPowerImage:Hide()
				outOfCombatTime = null
			end
		end
	
		elapsedTime = elapsedTime + elapsed
		if elapsedTime >= 0.1 then -- set back to 0.1 later
			UpdateShuffle()
			UpdateTigerPower()
			elapsedTime=0
		end
	end
end

-- Debug tools
local function GatherBuffData()
	local i = 1;

	--[[
	while UnitBuff("player", i) do
		local name, rank, iconTexture, count, debuffType, duration, expirationTime, one, two, three, four, spellID = UnitBuff("player", i)
		print("Buff " .. i .. ":")
		print("Name: " .. name)
		print("icon: ".. iconTexture)
		print("count: " .. count)
		print("duration in seconds: " .. duration)
		if spellID then
			print("Spell ID: " .. spellID)
		end
	end ]]
	
	
	for i=1,40 do 
		local n,_,icon,count,_,dur,x,_,_=UnitBuff("player",i);
		if n then
			print(i.."="..n..", "..icon..", "..dur.." seconds left.")
		end 
	end
	
end

-- Slash Commands
SLASH_NRTHRNALE1 = "/na"
SlashCmdList["NRTHRNALE"] = function(msg)
	if string.lower(msg) == "staghide" then
		NorthernAle.lstagtest:Hide()
		NorthernAle.rstagtest:Hide()
		NorthernAleOptions.fauxStaggerOn = false
	elseif string.lower(msg) == "stagshow" then
		NorthernAle.lstagtest:Show()
		NorthernAle.rstagtest:Show()
		NorthernAleOptions.fauxStaggerOn = true
	elseif string.lower(msg) == "buffdata" then
		GatherBuffData()
	elseif string.lower(msg) == "hide" then
		NorthernAle:Hide()
	elseif string.lower(msg) == "show" then
		NorthernAle:Show()
	elseif string.lower(msg) == "tigerpoweron" then
		NorthernAle.leftTigerPowerImage:Show()
		NorthernAle.rightTigerPowerImage:Show()
	elseif string.lower(msg) == "tigerpoweroff" then
		NorthernAle.leftTigerPowerImage:Hide()
		NorthernAle.rightTigerPowerImage:Hide()
	end
end